#--
# This code is automatically generated, do not modify the content !!!
#++
# Artifact is the representation of an complex information in the UES system. Everything in the UES system is information. A unit of
# information is an object. Some of the objects are more complicated and there are some extra characteristics which are useful to know.
# Some of these objects are needed for creating the UES structure and it is possible to aggregate other objects to them. These special
# objects are called artifacts. Artifacts enter into processes (activities) in a system or they are the results of processes. Artifacts
# have the same characteristics as objects plus some extra defined characteristics. Each piece of information in the system is represented
# as an Artifact or is a part of an artifact (it is an artifact's attribute or an aggregated object).
# 
# 
# 
# 
# <b>UES Artifact is service that provides operations over artifact.</b>
# 
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Artifact::UESArtifact
  private_class_method :new

  BEARTIFACT_CODE = Java::cz.ues.core.artifact.UESArtifact::BEARTIFACT_CODE #:nodoc:

  # URI of artifact business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_ARTIFACT = Java::cz.ues.core.artifact.UESArtifact::BETYPE_ARTIFACT


# Creates an artifact of class Artifact. Command creates new artifact in specified location. Meta artifact can be specified in
# UESArtifactCreate DTO, otherwise is used default meta artifact for territory. Competent role for artifact will be selected as
# the most suitable according to specified location and meta artifact (executive/authorized role with connected interface), or can be
# also specified in UESArtifactCreate DTO.
# 
# <tt><b>param</b></tt> locationUri URI of folder/org. unit/meta model where artifact will be created.
# 
# <tt><b>param</b></tt> artifact DTO containing attributes of a new artifact
# 
# <tt><b>return</b></tt> URI of created artifact.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(locationUri, artifact = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    artifact = Ues::Core::Artifact::UESArtifactCreate.new(artifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.create(locationUri, artifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command gets the attributes of the artifact specified by artifact URI and returns its detail.
# 
# <tt><b>param</b></tt> artifactUri URI of required artifact
# 
# <tt><b>return</b></tt> DTO with attributes of artifact
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(artifactUri)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.getAttributes(artifactUri)
    if (_r != nil) then _r = Ues::Core::Artifact::UESArtifactAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias attributes getAttributes
  end

# Command for setting attributes of artifact. Command can't modify references to object like storage, competent role and so on.
# 
# <tt><b>param</b></tt> artifactUri URI of required artifact
# 
# <tt><b>param</b></tt> artifact DTO containing attributes for updating the artifact
# 
# <tt><b>return</b></tt> URI of artifact
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.setAttributes(artifactUri, artifact = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    artifact = Ues::Core::Artifact::UESArtifactSetAttributes.new(artifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.setAttributes(artifactUri, artifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias set_attributes setAttributes
  end

# This command sets a new competent role for an artifact (asynchronously).
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact whose competency is about to be changed.
# 
# <tt><b>param</b></tt> newCompetency DTO containing attributes of the competency change
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.setCompetentRole(artifactUri, newCompetency = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    newCompetency = Ues::Core::Artifact::UESArtifactSetCompetentRole.new(newCompetency).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.setCompetentRole(artifactUri, newCompetency)
    
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias set_competent_role setCompetentRole
  end

# This command sets a new state of the specified artifact. The current state of an artifact can be retrieved by getAttributes command.
# Transition to the new state is driven by an activity on the artifact workflow. The activity itself sets the artifact state. There are
# three ways to specify this activity:
# 
# 
# 
# 1. The easiest way is to specify the required artifact state from the enumeration UESArtifactStateType. In this scenario, an appropriate
# activity template is found (an activity transforming the artifact to the required state) and it is used the same way as in the third
# scenario. If there is no such an activity template, the command fails. If there are a few such activities, then the first one is used
# (activity templates are ordered by name and code for this purpose).
# 
# 
# 
# 
# 2. By the same pattern, it is possible to specify UESURI of the artifact state template we want to set. The advantage compared
# to the first scenario is that we can also set some specific custom states that are not included in the enumeration UESArtifactStateType
# without knowing the activity template that sets it.
# 
# 
# 
# 
# 3. The UESURI of the activity template can be also specified directly. This activity has to contain an action to change the artifact
# state on its exit activity state. The activity is created and it changes the artifact state. If the activity contains an action with
# an attached script then the script is run first asynchronously and the artifact state is set after the script finishes successfully
# (therefore the artifact state can be actually set later, e.g. two minutes after setState command finishes).
# 
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact which state is about to be changed.
# 
# <tt><b>param</b></tt> state DTO containing details of the state change.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.setState(artifactUri, state = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    state = Ues::Core::Artifact::UESArtifactSetState.new(state).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.setState(artifactUri, state)
    
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias set_state setState
  end

# This command moves an artifact to the new location (folder, organizational unit, meta mode dictionary) in the same territory. It
# optionally leaves a shortcut at the original location.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact to be moved
# 
# <tt><b>param</b></tt> newLocation DTO containing details of the moving
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-06
  def self.move(artifactUri, newLocation = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    newLocation = Ues::Core::Artifact::UESArtifactMove.new(newLocation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.move(artifactUri, newLocation)
    
    return _r
  end

# This command deletes the specified artifact from the system. The artifact is deleted even if it contains a locked sheet or attachment.
# The artifact cannot be deleted when:
# 
# 
# * the artifact's workflow is not created
# 
# * a property contains a reference to this artifact
# 
# * a time sheet exists with a reference to this artifact
# 
# 
# 
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(artifactUri)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.delete(artifactUri)
    
    return _r
  end

# This command returns a list of all references from the specified artifact and / or all references to the specified artifact from / to
# his territory (command does not return references from / to other territories). The command does not return all references, only a
# sublist. The list of returned references can be filtered by the name and code of the artefact, by the meta artifact uri of the
# artifact, by the type of the reference, direction and the reference count. The list is sorted by the name, code and type by default, or
# it can be sorted arbitrarily by any of reference attributes usable for the filtering or these attributes combinations.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact to which and/or from which the references are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing references. Available parameters are: UESReferenceEntry#name name,
# UESReferenceEntry#code code, UESReferenceEntry#entityTypeUri entityTypeUri, UESReferenceEntry#type
# type : UESReferenceType UESReferenceType, UESReferenceEntry#direction direction :
# UESReferenceDirection UESReferenceDirection and UESReferenceEntry#count count.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing references to and/or from the artifactUri.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES7-01
  def self.getReferenceList(artifactUri, criteria = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    criteria = Ues::Core::Artifact::UESArtifactGetReferenceList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.getReferenceList(artifactUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias reference_list getReferenceList
  end

# This command sets an artifact presentation settings. The current presentation settings of an artifact can be retrieved by getAttributes
# command. Artifact presentation settings consists of width. Changing the width of the artifact changes the width of the content part of
# the artifact. Artifact width is used as default width for all artifact sheets and in visual use cases over artifact and its aggregated
# objects.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact which layout is about to be changed.
# 
# <tt><b>param</b></tt> presentation DTO containing presentation settings.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES7-01
  def self.setVisualPresentation(artifactUri, presentation = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    presentation = Ues::Core::Artifact::UESArtifactSetVisualPresentation.new(presentation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.setVisualPresentation(artifactUri, presentation)
    
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias set_visual_presentation setVisualPresentation
  end

# Configures presentation settings of an artifact. Artifact presentation settings consist of width, layout artifact UESURI, header
# visibility, toolbar visibility, and context menu visibility. All of these attributes control presentation of the artifact. When viewing
# an artifact, presentation settings are looked up in the following order: User settings, artifact presentation settings, meta artifact
# template presentation settings, and layout artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact whose presentation settings are to be changed.
# 
# <tt><b>param</b></tt> presentation DTO containing presentation settings.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.setPresentationAttributes(artifactUri, presentation = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    presentation = Ues::Core::Artifact::UESArtifactSetPresentationAttributes.new(presentation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.setPresentationAttributes(artifactUri, presentation)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias set_presentation_attributes setPresentationAttributes
  end

# Retrieves presentation settings of an artifact. Artifact presentation settings consist of width, layout artifact UESURI, header
# visibility, toolbar visibility, and context menu visibility. All of these attributes control presentation of the artifact. When viewing
# an artifact, presentation settings are looked up in the following order: User settings, artifact presentation settings, meta artifact
# template presentation settings, and layout artifact, if it is configured, or default system settings otherwise.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact whose presentation settings are to be retrieved.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.getPresentationAttributes(artifactUri)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.getPresentationAttributes(artifactUri)
    if (_r != nil) then _r = Ues::Core::Artifact::UESArtifactPresentationAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias presentation_attributes getPresentationAttributes
  end

# The command exports a artifact to a DataFile, which is saved to the Export Storage. The export is an asynchronous event. That is why it
# returns a process URI to enable the user to wait for the process to finish.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact to export
# 
# <tt><b>param</b></tt> artifact DTO that contains attributes of the export process
# 
# <tt><b>return</b></tt> UESURI of the export process
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES8-03
  def self.export(artifactUri, artifact = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    artifact = Ues::Core::Artifact::UESArtifactExport.new(artifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.export(artifactUri, artifact)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# The command returns a data file generated by the export command. The file contains an exported artifact.
# 
# <tt><b>param</b></tt> artifactUri UESURI of the artifact we want to get the exported file from.
# 
# <tt><b>param</b></tt> artifact DTO that contains attributes concerning the file returned.
# 
# <tt><b>return</b></tt> Data file of an exported artifact.
# 
# <tt><b>throws</b></tt> UESArtifactRTException
# 
# <tt><b>since</b></tt> UES8-04
  def self.getExportData(artifactUri, artifact = nil)
    artifactUri = Ues::Core::Commons::Uri::UESURI.new(artifactUri).to_java
    artifact = Ues::Core::Artifact::UESArtifactGetExportData.new(artifact).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifact.java_class)
    _r = _s.getExportData(artifactUri, artifact)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESStreamHandler.new(_r) end
    return _r
  end
  class << Ues::Core::Artifact::UESArtifact
    alias export_data getExportData
  end
end
