#--
# This code is automatically generated, do not modify the content !!!
#++
# UES Artifact Search is a service that provides search operations over
# artifacts.
# 
# <tt><b>author</b></tt> uni428
class Ues::Core::Artifact::UESArtifactSearch
  private_class_method :new


# Performs a search for artifacts with specified criteria. The search is performed in the location
# according to the locationUri, although it can be widened by using includeSystemArea or
# includePreferredArea flag in the search query.
# 
# 
# 
# 
# Search criteria contains several search settings - query (what to search,
# and order settings) and paging settings.
# 
# 
# <tt><b>param</b></tt> locationUri The location to search in. Can be a territory or an
# organizational unit.
# 
# <tt><b>param</b></tt> searchQuery DTO containing search criteria. Available query
# parameters are: UESArtifactSearchResultItem#name name,
# UESArtifactSearchResultItem#code code,
# UESArtifactSearchResultItem#uri uri,
# UESArtifactSearchResultItem#organizationalUnitName
# organizationalUnitName (cannot use fulltext operator),
# UESArtifactSearchResultItem#organizationalUnitUri
# organizationalUnitUri,
# UESArtifactSearchResultItem#metaArtifactUri
# metaArtifactUri,
# UESArtifactSearchResultItem#metaArtifactCode
# metaArtifactCode, UESArtifactSearchResultItem#stateType
# stateType: UESArtifactStateType UESArtifactStateType and
# UESArtifactSearchResultItem#entityTypeUri entityTypeUri.
# 
# <tt><b>see</b></tt> <a
# href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY"
# target="_blank">UESQuery Documentation</a>
# 
# <tt><b>return</b></tt> The list of found artifacts.
# 
# <tt><b>throws</b></tt> UESArtifactSearchRTException Thrown when search settings are
# invalid or when searching fails for other reason.
# 
# <tt><b>since</b></tt> UES6-06
  def self.query(locationUri, searchQuery = nil)
    locationUri = Ues::Core::Commons::Uri::UESURI.new(locationUri).to_java
    searchQuery = Ues::Core::Artifact::UESArtifactSearchQuery.new(searchQuery).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.artifact.UESArtifactSearch.java_class)
    _r = _s.query(locationUri, searchQuery)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
end
