#--
# This code is automatically generated, do not modify the content !!!
#++
# UES Property service.
# 
# <tt><b>since</b></tt> UES6-00
class Ues::Core::Property::UESProperty
  private_class_method :new

  BEPROPERTY_CODE = Java::cz.ues.core.property.UESProperty::BEPROPERTY_CODE #:nodoc:

  # URI of property business entity.
# 
# <tt><b>since</b></tt> UES6-06
  BETYPE_PROPERTY = Java::cz.ues.core.property.UESProperty::BETYPE_PROPERTY


# Returns attributes representing the artifact property specified by the <code>propertyUri</code> attribute.
# 
# <tt><b>param</b></tt> propertyUri UESURI of Property
# 
# <tt><b>return</b></tt> DTO with artifact property attributes
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getAttributes(propertyUri)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.getAttributes(propertyUri)
    if (_r != nil) then _r = Ues::Core::Property::UESPropertyAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias attributes getAttributes
  end

# This command sets a new value on the specified property. The data type of value must match the data type of the specified property.
# 
# <tt><b>param</b></tt> propertyUri UES URI of property
# 
# <tt><b>param</b></tt> value the new value of property (<code>null</code> is allowed) 
# Possible types of property's value:
# 
# 
# * <code>NUMBER</code> - Double, format: real number
# 
# * <code>DATE</code> - Date, only date will be used from value, information of time will be lost
# 
# * <code>SHORT_TEXT</code> - String, format: <code>name</code>
# 
# * <code>TEXT</code> - String, format: <code>description</code>
# 
# * <code>REFERENCE</code> - String, format: <code>UES-URI</code>
# 
# * 
# <code>INTERTERRITORIAL_REFERENCE (inter-territorial reference)</code> - String , format: <code>UES-URI</code>
# 
# * <code>URL</code> - String, format of value: <code>URL</code>
# 
# * <code>BINARY</code> - UESStreamHandler, format of value: binary data
# 
# 
# 
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.setValue(propertyUri, value = nil)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    value = Ues::Core::Property::UESProperty.send("convert_to_java", value)
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.setValue(propertyUri, value)
    
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias set_value setValue
  end

# This command returns a value on the specified property.
# 
# <tt><b>param</b></tt> <T> data type of the value. (For Binary type is returned UESStreamHandler).
# 
# <tt><b>param</b></tt> propertyUri UES URI of the property
# 
# <tt><b>return</b></tt> a value on the specified property
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.getValue(propertyUri)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.getValue(propertyUri)
    _r = Ues::Core::Property::UESProperty.send("convert_to_ruby", _r)
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias value getValue
  end

# This command creates a new property on the specified artifact or in the specified property collection. At the very least property
# template or the property type and name have to be specified in this command. Value of the property is optional. The data are streamed
# in case of type BINARY property.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the artifact or of the property collection where the new property is created
# 
# <tt><b>param</b></tt> property DTO containing attributes of a new property
# 
# <tt><b>return</b></tt> UESURI of the created property
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>throws</b></tt> UESPropertyValidationRTException
# 
# <tt><b>since</b></tt> UES6-00
  def self.create(parentNodeUri, property = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    property = Ues::Core::Property::UESPropertyCreate.new(property).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.create(parentNodeUri, property)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end

# This command returns a list of properties in the specified property collection or on the specified artifact <s>(properties from the
# artifact root property collection are returned in that case)</s>. Command does not return all properties, only a sublist. The list of
# returned properties could be filtered by the name or code of a property and it is sorted by names (and codes in case two names are
# equal). 
# <b>Since UES7-04</b> - if the input parameter <code>parentNodeUri</code> is artifact (not property collection), all properties of the
# specified artifact are returned.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the artifact or of the property collection from where properties are listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing properties. Available parameters are: UESPropertyAttributes#name name and
# UESPropertyAttributes#code code.
# 
# <tt><b>see</b></tt> <a href="https://uu.unicornuniverse.eu/ues/sesm?&SessFree=ues:UNI-BT:UES.DOC%2FCMD_V1%2FUESQUERY" target="_blank">UESQuery
# Documentation.</a>
# 
# <tt><b>return</b></tt> List of DTO representing properties. The same DTO as in the command getAttributes
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES6-00
# 
# <tt><b>deprecated</b></tt> This command is no longer supported and developed. Use alternative command - UESProperty.getEntryList.
  def self.getPropertyList(parentNodeUri, criteria = nil)
    warn "[DEPRECATED: Ues::Core::Property::UESProperty.getPropertyList] This command is no longer supported and developed. Use alternative command - UESProperty.getEntryList."
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    criteria = Ues::Core::Property::UESPropertyGetPropertyList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.getPropertyList(parentNodeUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias property_list getPropertyList
  end

# This command deletes the property from the system.
# 
# <tt><b>param</b></tt> propertyUri UESURI of the property which is about to be deleted.
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES6-10
  def self.delete(propertyUri)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.delete(propertyUri)
    
    return _r
  end

# This command sets attributes of the specified property.
# 
# <tt><b>param</b></tt> propertyUri UESURI of the property whose attributes are about to be changed.
# 
# <tt><b>param</b></tt> property DTO containing the attributes of the property to be set.
# 
# <tt><b>return</b></tt> UESURI of the modified property.
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.setAttributes(propertyUri, property = nil)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    property = Ues::Core::Property::UESPropertySetAttributes.new(property).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.setAttributes(propertyUri, property)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias set_attributes setAttributes
  end

# This command creates a new property collection on the specified artifact or in the specified property collection. At the very least
# property collection name has to be specified in this command.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the artifact or of the property collection where the new property collection is created.
# 
# <tt><b>param</b></tt> propertyCollection DTO containing attributes of the new property collection.
# 
# <tt><b>return</b></tt> UESURI of the new property collection.
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.createCollection(parentNodeUri, propertyCollection = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    propertyCollection = Ues::Core::Property::UESPropertyCreateCollection.new(propertyCollection).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.createCollection(parentNodeUri, propertyCollection)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias create_collection createCollection
  end

# This command returns attributes representing the property collection specified by the collectionUri parameter. The command does not
# change the state of the property collection in the system.
# 
# <tt><b>param</b></tt> collectionUri UESURI of the property collection which attributes are returned.
# 
# <tt><b>return</b></tt> UESPropertyCollectionAttributes DTO containing the property collection attributes
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.getCollectionAttributes(collectionUri)
    collectionUri = Ues::Core::Commons::Uri::UESURI.new(collectionUri).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.getCollectionAttributes(collectionUri)
    if (_r != nil) then _r = Ues::Core::Property::UESPropertyCollectionAttributes.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias collection_attributes getCollectionAttributes
  end

# This command sets attributes of the specified property collection.
# 
# <tt><b>param</b></tt> collectionUri UESURI of the property collection whose attributes are about to be changed.
# 
# <tt><b>param</b></tt> propertyCollection DTO containing the attributes of the property collection to be set.
# 
# <tt><b>return</b></tt> UESURI of the property collection whose attributes are to be changed.
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.setCollectionAttributes(collectionUri, propertyCollection = nil)
    collectionUri = Ues::Core::Commons::Uri::UESURI.new(collectionUri).to_java
    propertyCollection = Ues::Core::Property::UESPropertySetCollectionAttributes.new(propertyCollection).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.setCollectionAttributes(collectionUri, propertyCollection)
    if (_r != nil) then _r = Ues::Core::Commons::Uri::UESURI.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias set_collection_attributes setCollectionAttributes
  end

# This command deletes the specified property collection from the system. When the collection is not empty, it's need explicite to allow
# deletion of the collection with its all nested objects.
# 
# <tt><b>param</b></tt> collectionUri UESURI of the property collection which is about to be deleted
# 
# <tt><b>param</b></tt> option DTO containing settings for deletion
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.deleteCollection(collectionUri, options = nil)
    collectionUri = Ues::Core::Commons::Uri::UESURI.new(collectionUri).to_java
    options = Ues::Core::Property::UESPropertyDeleteCollection.new(options).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.deleteCollection(collectionUri, options)
    
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias delete_collection deleteCollection
  end

# This command returns a list of entries (properties or property collections) enlisted in the specified property collection or on the
# specified artifact (properties from the artifact root property collection are returned in that case). Command does not return all
# entries, only a sublist. The list of returned entries could be filtered by the name, code or type of an entry. The list is sorted by
# the name (and codes in case are equal) of a entry by default, or it can be sorted arbitrarily by any of entry attributes usable for the
# filtering or these attributes combinations. See the UES query documentation for more information.
# 
# <tt><b>param</b></tt> parentNodeUri UESURI of the artifact or of the property collection from where entries (properties or property collections) are
# listed.
# 
# <tt><b>param</b></tt> criteria DTO containing criteria for listing entries.
# 
# <tt><b>return</b></tt> List of DTO representing property entries (properties or property collections)
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.getEntryList(parentNodeUri, criteria = nil)
    parentNodeUri = Ues::Core::Commons::Uri::UESURI.new(parentNodeUri).to_java
    criteria = Ues::Core::Property::UESPropertyGetEntryList.new(criteria).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.getEntryList(parentNodeUri, criteria)
    if (_r != nil) then _r = Ues::Platform::Commons::Lang::UESResultList.new(_r) end
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias entry_list getEntryList
  end

# This command moves a property collection to the new location in the same artifact. This collection can not be base collection. New
# location can be property collection or artifact, and it can not be child of property collection which is about to move. New location
# can not be child of the moved collection. User must have access rights to modify property collection on artifact to which is collection
# related.
# 
# <tt><b>param</b></tt> collectionUri UESURI of the property collection which is about to be moved.
# 
# <tt><b>param</b></tt> newLocation DTO contains parameters that specify the move
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.moveCollection(collectionUri, newLocation = nil)
    collectionUri = Ues::Core::Commons::Uri::UESURI.new(collectionUri).to_java
    newLocation = Ues::Core::Property::UESPropertyMoveCollection.new(newLocation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.moveCollection(collectionUri, newLocation)
    
    return _r
  end
  class << Ues::Core::Property::UESProperty
    alias move_collection moveCollection
  end

# Moves the specified property to a new location in same artifact in which the property is. 
#  
# For the property move - the logged user, which invokes this command, must have access rights to modify target property collection.
# 
# <tt><b>param</b></tt> propertyUri UESURI of the property which is about to be moved.
# 
# <tt><b>param</b></tt> newLocation DTO containing attributes specifying a location to where the property is about to be moved.
# 
# <tt><b>throws</b></tt> UESPropertyRTException
# 
# <tt><b>since</b></tt> UES7-04
  def self.move(propertyUri, newLocation = nil)
    propertyUri = Ues::Core::Commons::Uri::UESURI.new(propertyUri).to_java
    newLocation = Ues::Core::Property::UESPropertyMove.new(newLocation).to_java
    _s = Java::cz.ues.platform.container.UESComponentFactory.getComponent(Java::cz.ues.core.property.UESProperty.java_class)
    _r = _s.move(propertyUri, newLocation)
    
    return _r
  end

  def self.convert_to_java(value) #:nodoc:
    if (value.java_kind_of?File)
      if (value.java_kind_of?File) then value = Java::java.io.File.new(value.path) end
    elsif (value.java_kind_of?Array)
      if (value != nil) then _t = []; value.to_a.each do |_e|; _e = convert_to_java(_e); _t << _e; end; value = Java::java.util.ArrayList.new(_t); end;
    elsif ((value.java_kind_of?Fixnum) || (value.java_kind_of?Float) || (value.java_kind_of?Bignum))
      if ((value.java_kind_of?Fixnum) || (value.java_kind_of?Float) || (value.java_kind_of?Bignum)) then value.to_java end
    elsif (value.java_kind_of?Exception)
      if (value.java_kind_of?NativeException) then value = value.cause elsif (value.java_kind_of?Exception) then; _t = []; begin value.backtrace.each do |_e|; _p = _e.split(":"); _t.push(Java::java.lang.StackTraceElement.new(_p[0], "", _p[2], Integer(_p[1]))); end; rescue; end; value = Java::java.lang.Exception.new(value.message); value.setStackTrace(_t.to_java(Java::java.lang.StackTraceElement)); end;
    else
      if ((!value.java_kind_of?Java::java.lang.Object) && (value.class.method_defined?"to_java")) then value = value.to_java end
    end
    return value
  end
  private_class_method :convert_to_java

  def self.convert_to_ruby(value) #:nodoc:
  	if (value == nil)
  	  return value
  	elsif (value.java_kind_of?Java::java.util.Date)
  	  if (value != nil) then value = Time.at(value.getTime/1000) end
    elsif (value.java_kind_of?Java::javax.xml.datatype.XMLGregorianCalendar)
      if (value != nil) then value = Time.at(value.toGregorianCalendar.getTimeInMillis/1000) end
    elsif (value.java_kind_of?Java::java.io.InputStream)
      if (value != nil) then value = Java.java_to_ruby(org.jruby.RubyIO.new(JRuby.runtime, value).java_object) end
    elsif (value.java_kind_of?Java::java.io.OutputStream)
      if (value != nil) then value = Java.java_to_ruby(org.jruby.RubyIO.new(JRuby.runtime, value).java_object) end
    elsif (value.java_kind_of?Java::java.io.File)
      if (value != nil) then if (File.exist?value.getPath) then value = File.new(value.getPath, "r") else value = File.new(value.getPath, "a") end end
    elsif (value.java_kind_of?Java::java.util.Collection)
      _t = [];value.to_a.each do |_e|; _e = convert_to_ruby(_e); _t << _e; end; value = _t;
    elsif (value.java_kind_of?Java::java.util.Iterator)
      _t = []; value.to_a.each do |_e|; _e = convert_to_ruby(_e); _t << _e; end; value = _t.each;
    else
      dto = dto_class(value); if (dto != nil) then if (value != nil) then value = dto.new(value) end; end;
    end
    return value
  end
  private_class_method :convert_to_ruby
  
  def self.dto_class(value) #:nodoc:
    name = value.class.to_s
    if (name.start_with?("Java"))
      _t = name.gsub(/[A-Z]/) {|c| ' ' + c}.split(" ")
      if (_t.size < 5)
        return nil
      end
      name = _t[2] + "::" + _t[3] + "::" + _t[4] + "::" + name[name.rindex(":") + 1, name.length]
      begin
        return Module.class_eval(name)
      rescue NameError
        return nil
      end
    elsif ((name.start_with?("#")) || (name["Ues::"] == nil))
      return nil
    else
      return value.class
    end
  end
  private_class_method :dto_class

end
